#ifndef _ZIGZAG_H
#define _ZIGZAG_H

#include "idct.h"

// Table for transforming from zig-zag order to natural order.
// We use the same trick as libjpeg here; there are 16 extra entries
// after the end of the table, since the run-length decoder could
// potentially cause entries indices >= 64 to be decoded.
static const unsigned unzigzag[DCTSIZE2 + 16] = {
	// Regular entries.
	 0,  1,  8, 16,  9,  2,  3, 10,
	17, 24, 32, 25, 18, 11,  4,  5,
	12, 19, 26, 33, 40, 48, 41, 34,
	27, 20, 13,  6,  7, 14, 21, 28,
	35, 42, 49, 56, 57, 50, 43, 36,
	29, 22, 15, 23, 30, 37, 44, 51,
	58, 59, 52, 45, 38, 31, 39, 46,
	53, 60, 61, 54, 47, 55, 62, 63,

	// Extra padding entries; should never be referenced in well-formed data.
	63, 63, 63, 63, 63, 63, 63, 63,
	63, 63, 63, 63, 63, 63, 63, 63,
};

#endif /* !defined(_ZIGZAG_H) */
